/*
 * Copyright (c) 2014 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*global define, window, document, tau*/

/**
 * Init page module.
 *
 * @module views/init
 * @requires {@link core/event}
 * @requires {@link core/application}
 * @requires {@link core/systeminfo}
 * @requires {@link views/main}
 * @namespace views/init
 * @memberof views
 */

define({
    name: 'views/init',
    requires: [
        'core/event',
        'core/application',
        'core/systeminfo',
        'views/main'
    ],
    def: function viewsInit(req) {
        'use strict';

        /**
         * Core event module object.
         *
         * @private
         * @type {Module}
         */
        var e = req.core.event,

            /**
             * Core application module object.
             *
             * @private
             * @type {Module}
             */
            app = req.core.application,

            /**
             * Core systeminfo module object.
             *
             * @private
             * @type {Module}
             */
            sysInfo = req.core.systeminfo,

            /**
             * Not supported message.
             *
             * @private
             * @const {string}
             */
            SENSOR_NOT_SUPPORTED_MSG =
                'UV sensor is not supported on this device.',

            /**
             * List of images to preload.
             *
             * @private
             * @type {string[]}
             */
            imagesToPreload = [
                'images/sun.png',
                'images/sun_0.png',
                'images/sun_1.png',
                'images/sun_2.png',
                'images/sun_3.png'
            ];

        /**
         * Loads UI images.
         *
         * @private
         */
        function preloadImages() {
            var image = null,
                length = imagesToPreload.length,
                i = 0;

            for (i = 0; i < length; i += 1) {
                image = new window.Image();
                image.src = imagesToPreload[i];
            }
        }

        /**
         * Registers event listeners.
         *
         * @private
         */
        function bindEvents() {
            document.addEventListener('tizenhwkey', function onTizenHWKey(e) {
                if (e.keyName === 'back') {
                    app.exit();
                }
            });
            sysInfo.listenBatteryLowState();
        }

        /**
         * Handles core.battery.low event.
         *
         * @private
         */
        function onLowBattery() {
            app.exit();
        }

        /**
         * Handles models.sensor.not.supported event.
         *
         * @private
         */
        function onSensorNotSupported() {
            document.getElementById('alert-message').innerText =
                SENSOR_NOT_SUPPORTED_MSG;
            tau.openPopup(document.getElementById('alert'));
        }

        /**
         * Initializes module.
         *
         * @memberof views/init
         * @public
         */
        function init() {
            preloadImages();
            bindEvents();
            sysInfo.checkBatteryLowState();
        }

        e.listeners({
            'core.battery.low': onLowBattery,
            'models.sensor.not.supported': onSensorNotSupported
        });

        return {
            init: init
        };
    }

});
